#ifndef GUARD_ag_sim_h
#define GUARD_ag_sim_h
/***************************************************************************
                          ag_sim.h  -  description
                             -------------------
    begin                : Sat Mar 6 2004
    copyright            : (C) 2004 by Goran Frehse
    email                : goran.frehse@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "stopwatch.h"
#include "automaton.h"
  
map <label_ref,state_relation> ag_sim_get_nBtr1(automaton& P1, automaton& Q2, automaton& Q1, automaton& P1Q2, location_ref_to_location_ref_pair_map lr_lrp_map, const state_relation& R);

state_relation ag_sim_get_Bte(automaton& P1, automaton& Q2, automaton& Q1, automaton& P1Q2, location_ref_to_location_ref_pair_map lr_lrp_map, const state_relation& R);

void get_ag_Rel_pre(clock_val_set& cvs_equiv_P1Q2Q1, automaton& P1, automaton& Q2, automaton& Q1, automaton& P2, automaton& P1Q2, location_ref_to_location_ref_pair_map& loc_map_P1Q2, state_relation& R1, map <string,label_ref>& label_map, map <label_ref,state_relation>& nBtr1, state_relation& Bte1);

map <label_ref,state_relation> ag_sim_get_Dtr(automaton& P1, automaton& Q2, automaton& Q1, automaton& P1Q2, state_relation& R,map <label_ref,state_relation>& Btr,location_ref_to_location_ref_pair_map& loc_map_P1Q2);
state_relation ag_sim_get_Dte(automaton& P1, automaton& Q2, automaton& Q1, automaton& P1Q2, state_relation& R,state_relation& Bte,location_ref_to_location_ref_pair_map& loc_map_P1Q2);
void get_ag_Dts(automaton& P1, automaton& Q2, automaton& Q1, automaton& P2, automaton& P2Q1, state_relation& R2, map <label_ref,state_relation>& nBtr2, state_relation& Bte2, map <label_ref,state_relation>& Dtr2, state_relation& Dte2,location_ref_to_location_ref_pair_map& loc_map_P2Q1);

void get_ag_Rel_post(clock_val_set& cvs_equiv_P1Q2Q1, automaton& P1, automaton& Q2, automaton& Q1, automaton& P2, automaton& P1Q2, location_ref_to_location_ref_pair_map& loc_map_P1Q2, state_relation& R1, map <label_ref,state_relation>& Dtr2, state_relation& Dte2);

bool is_ag_simulation(automaton& P1, automaton& P2, automaton& Q1, automaton& Q2);

#endif
